diff --git i/src/bin/psql/common.c w/src/bin/psql/common.c
index 5ab736e..18260f1 100644
--- i/src/bin/psql/common.c
+++ w/src/bin/psql/common.c
@@ -166,6 +166,8 @@ psql_error(const char *fmt,...)
 
 	if (pset.inputfile)
 		fprintf(stderr, "%s:%s:" UINT64_FORMAT ": ", pset.progname, pset.inputfile, pset.lineno);
+	else if (!isatty(fileno(stdin)))
+		fprintf(stderr, "%s:<stdin>:" UINT64_FORMAT ": ", pset.progname, pset.lineno);
 	va_start(ap, fmt);
 	vfprintf(stderr, _(fmt), ap);
 	va_end(ap);
